<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="130px"
      v-loading="formLoading"
    >
      <el-form-item label="职位中文名称" prop="nameCn">
        <el-input v-model="formData.nameCn" placeholder="请输入职位中文名称" />
      </el-form-item>
      <el-form-item label="职位英文名称" prop="nameEn">
        <el-input v-model="formData.nameEn" placeholder="请输入职位英文名称" />
      </el-form-item>
      <!-- <el-form-item label="上级id" prop="parentId">
        <el-tree-select
          v-model="formData.parentId"
          :data="positionTree"
          :props="{...defaultProps, label: 'nameCn'}"
          check-strictly
          default-expand-all
          placeholder="请选择上级id"
        />
      </el-form-item>
      <el-form-item label="层级" prop="level">
        <el-radio-group :disabled="disabled" v-model="formData.level">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item> -->
      <el-form-item label="默认职位要求" prop="requirement">
        <Editor v-model="formData.requirement" height="150px" />
      </el-form-item>
      <el-form-item label="默认职位描述内容" prop="content">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
      <el-form-item label="行业排序" prop="sort">
        <el-input-number v-model="formData.sort" :min="0" placeholder="请输入行业排序" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { PositionApi, PositionVO } from '@/api/menduner/system/position'
// import { defaultProps, handleTree } from '@/utils/tree'

/** 职位信息 表单 */
defineOptions({ name: 'PositionForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  nameCn: undefined,
  nameEn: undefined,
  parentId: 0,
  level: 1,
  sort: 0,
  requirement: undefined,
  content: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref
// const positionTree = ref() // 树形结构
// const disabled = ref(false)

/** 打开弹窗 */
const open = async (type: string, id?: number, level?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id && !level) {
    formLoading.value = true
    try {
      const res = await PositionApi.getPosition(id)
      if (!res) return
      // 富文本不能为null
      if (res.requirement === null) res.requirement = undefined
      if (res.content === null) res.content = undefined
      formData.value = res
    } finally {
      formLoading.value = false
    }
  }
  // await getPositionTree()
  if (level) {
    // disabled.value = true
    formData.value.parentId = id
    formData.value.level = Number(level) + 1
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as PositionVO
    if (formType.value === 'create') {
      await PositionApi.createPosition(data)
      message.success(t('common.createSuccess'))
    } else {
      await PositionApi.updatePosition(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    nameCn: undefined,
    nameEn: undefined,
    parentId: 0,
    level: 1,
    sort: 0,
    requirement: undefined,
    content: undefined
  }
  // disabled.value = false
  formRef.value?.resetFields()
}

/** 获得职位信息树 */
// const getPositionTree = async () => {
//   positionTree.value = []
//   const data = await PositionApi.getPositionList({})
//   const root: Tree = { id: 0, name: '顶级职位信息', children: [] }
//   root.children = handleTree(data, 'id', 'parentId')
//   positionTree.value.push(root)
// }
</script>